declare type Predicate<T> = (t: T) => boolean;
declare type Function<T, R> = (t: T) => R;
declare type Type<T> = new (...args: any[]) => T;
interface ICase<T, R> {
    matches: Predicate<T>;
    fn: Function<T, R>;
}
interface IDefaultCase<R> {
    value: R;
}
declare function Case<R>(value: string, fn: Function<string, R>): ICase<string, R>;
declare function Case<R>(value: number, fn: Function<number, R>): ICase<number, R>;
declare function Case<T, R>(value: Type<T>, fn: Function<T, R>): ICase<T, R>;
declare function DefaultCase(): IDefaultCase<void>;
declare function DefaultCase(value: number): IDefaultCase<number>;
declare function DefaultCase<R>(value: R): IDefaultCase<R>;
declare function match<T, R>(input: T, defaultCase: IDefaultCase<R>, ...cases: ICase<T, R>[]): R;
export { Predicate, Function, Type, ICase, Case, IDefaultCase, DefaultCase, match };
